<!--objects_weblog_approval.jsp

Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: objects_weblog_approval.jsp 93076 2015-12-03 08:10:45Z bchan $
-->

<!--
This file receives notification messages from workflow activities
and queues the events for the recipient
-->

<html>

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.impl.util.*" %>
<%@ page import="com.xerox.docushare.impl.DSMainConstants" %>
<%@ page import="com.xerox.docushare.impl.client.DSSessionImpl" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% 
long t0 = System.currentTimeMillis();
// set recipient from logged user
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
try{
    dsrouting.setDSSession(request); 
}catch(DSAuthorizationException e){
    out.print(MessageDB.get("routing_not_authorized", locale));
    return;
}
String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+
String requestURL = dsrouting.getRequestURL(request);
String contextPath = request.getContextPath();
%>

<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
    <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>

<%

String preselectedTaskHandle = request.getParameter( "preselectedTask" );
DSObject taskObject = dsSession.makeEmptyObject( new DSHandle( preselectedTaskHandle ) );

DSHandle recipient = dsSession.getLoginPrincipalHandle(); //use dsSession to decide recipient
DSSession adminSession = null;
try
{   com.xerox.docushare.config.ServiceLocator serviceLocator = com.xerox.docushare.config.ConfigLocatorFactory.createServiceLocator( System.getProperties() );
    String rmiName = serviceLocator.getAddress( DSMainConstants.DSSERVER, com.xerox.docushare.config.ServiceLocator.DSSERVICE );
    com.xerox.docushare.monitor.DSService dssvc = (com.xerox.docushare.monitor.DSService) java.rmi.Naming.lookup(rmiName);
    adminSession = dsSession.getServer().createSession( dssvc.getCredential(DSMainConstants.PASSWORD) );            
}
catch ( Exception e) {
    throw new DSException(DSException.NETWORK_COMMUNICATION_PROBLEM, e);
}
//DSWorkflowManager wfm = dsSession.getDSWorkflowManager(); //this will reply on Full Workflow Service license bit
DSWorkflowManager wfm = ((DSSessionImpl)adminSession).getDSWorkflowManager(DSMainConstants.PASSWORD); //SG+

//get workflow, then task ID of the recipient:
Integer wfID = (Integer)taskObject.get(DSObject.routing_template_id);
DSWorkflow workflow = wfm.getWorkflow(new DSWorkflowID(wfID.intValue()));
//loop tasks to find recipient, in case same recipient in multiple tasks, always return first:
int tID = 0;
DSTask[] tsk = workflow.getTasks();
for(int i=0; i<tsk.length; i++)
{   if(recipient.equals(tsk[i].getResource()) && (tsk[i] instanceof DSRoutingTask))
    {   tID = tsk[i].getDSTaskID().getValue();
        break;
    }
}
String requestUrlStr = "request_base.jsp?routingSlipRequestID="+ tID +"&workFlowJobName=" + wfID.intValue();

response.sendRedirect( requestUrlStr );

%>
<HEAD>
   <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html">
</HEAD>
<body bgcolor="<%= dsrouting.getBgcolor() %>" class="routing-dialog-body">
THIS IS A BIG FAT ERROR THAT SHOULD NEVER HAPPEN
</body>
</html>
