<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--prop_add.jsp

Copyright (C) 2001 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2001 Xerox Corporation. All Rights Reserved.

Author: Philip Gust
Version: $Id: prop_add.jsp 93076 2015-12-03 08:10:45Z bchan $
-->

<!--
This file displays a services "Add" page.  This page is meant to be
displayed within the cut-down services page from document routing
request and report pages.
-->
<%@ page import="java.io.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.util.*" %>

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="jp.co.fujixerox.docushare.amber.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% dsrouting.setDSSession(request); 
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+

// set userName from logged user
final WebRequest webRequest = (WebRequest)request.getAttribute("WebSession");
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
final DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
final String user = dsUser.getHandle().toString();
final String userName = GenericUtil.getShortName(dsUser, dsSession);;

final String  workFlowJobName = (String) webRequest.getParameter("workFlowJobName");
int workflowID = 0;
try { workflowID = Integer.parseInt(workFlowJobName); 
}catch(Exception e) {}
if(workFlowJobName == null || workflowID ==0) 
    throw new DSException(0, MessageDB.get("routing_missing_parameter", new Object[] {"workFlowJobName"}, locale));
final String document = (String) webRequest.getParameter("document"); //current version handle on request page
if(document == null) 
    throw new DSException(0, MessageDB.get("routing_missing_parameter", new Object[] {"document"}, locale));

DSVersion curVersion = null;  //current version object on request page
DSDocument dsDoc = null;      //parent document of current version
boolean isPubNew = false;     //true: owner publish new version; false: reviewer add draft version
DSHandle newVersionHandle = null;

String pubNew = webRequest.getParameter("_pubNew");
isPubNew = (pubNew != null);
//System.out.println("prop_add.jsp: pubNew = "+ pubNew +", isPubNew = " + isPubNew);

// set the return parameters for displaying "breadcrumbs"
final String submitValue = (String) webRequest.getParameter("submit");
final String returnTo = webRequest.getParameter("return");
String returnToTag = webRequest.getParameter("returnTag");
if(submitValue == null)
    returnToTag = request.getParameter("returnTag"); //AR15507: replace webRequest with request
if (returnToTag == null) {
    returnToTag = "Top";
}

final String applyLabel = MessageDB.get("button.apply", locale);
String title = MessageDB.get("routing_add_version", locale);
String action = "Add";
String errorMessage = null;           // record error messages during processing
int errorCode = 0;                    //DSException.errorCode
boolean autoMovePreferredVersion = true; //AR6781+
String contextPath = request.getContextPath();

try {
    curVersion = (DSVersion)dsSession.getObject(new DSHandle(document), new DSSelectSet(DSObject.title));
    dsDoc = curVersion.getDocument(new DSSelectSet(DSObject.title));
    autoMovePreferredVersion = dsDoc.getAutoMovePreferredVersion() || dsDoc.isDraft(); //AR6781
} catch (DSException ex) {
    System.out.println("prop_add.jsp: problem to get document "+ document +": " + ex);
    errorMessage = ex.getMessage();
    errorCode = ex.getErrorCode();
}
%>
<html xmlns="http://www.w3.org/1999/xhtml">
<HEAD>
    <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <TITLE><%= title %></TITLE>
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
    <script language="javascript">
    <!--
    // JavaScript for document routing functions
    <%@include file="document_routing.js" %>
    //-->
    </script>

</HEAD>
<%
if (errorMessage != null) {//error to get document
    //do not do add draft, later (at around line 260) will show errorMessage.
}
else if (applyLabel.equals(submitValue)) {//add draft or new version
    FileUploadWebRequest uploadRequest;
    if (webRequest instanceof FileUploadWebRequest)
        uploadRequest = (FileUploadWebRequest)webRequest;
    else
        throw new Exception("webRequest instance is not FileUploadWebRequest, but " + webRequest.getClass().getName() + "! ");
    File docFile = (File)uploadRequest.getTempFile();          // the uploaded file
    //String docType = (String)uploadRequest.getFileType();    // the mime type of the uploaded file
    String docFileName = (String)uploadRequest.getFileName();  // the name of the uploaded file name

    String redirectToURL = null;

    if (docFile == null) {
        errorMessage = MessageDB.get("routing_error_blank_field", locale);
    } else {
        try {
            boolean setVersionPreferred = "true".equals(webRequest.getParameter("setVersionPreferred"));
            //reviewer add draft or owner publish new:
            newVersionHandle = dsrouting.addVersionToRoutedDocument(workflowID, dsDoc, user, isPubNew, 
                docFile.getPath(), docFileName, (String)webRequest.getParameter("version_title"), 
                (String)webRequest.getParameter( "revision_comments" ), setVersionPreferred);

            // convert to handle for redirect
            redirectToURL = "prop_all.jsp?document=" + newVersionHandle.toString();
            if (returnTo != null) {
                redirectToURL += "&workFlowJobName=" + workFlowJobName + "&submit=Apply";
                redirectToURL += "&returnTag=" + URLEncoder.encode(returnToTag, "UTF-8")+ "&return=" + URLEncoder.encode(returnTo, "UTF-8");
                //System.out.println("prop_add.jsp: redirectToURL = " + redirectToURL);
            }
        } catch (DSException ex) {
            errorMessage = ex.getMessage();
            errorCode = ex.getErrorCode();
            System.out.println("prop_add.jsp user to add draft version, publish this version or add new version: errorCode "
             + errorCode + ", " + ex);
        } finally {            
            try {
                docFile.delete(); // clean up temp file
            } catch (Exception ex) {// ignore all 
            }
        }
    }//docFile !=null
    if ((errorMessage == null) && (redirectToURL != null)) {
%>
<script language="javascript">
<!--
    self.location = "<%= redirectToURL %>";
//-->
</script>
<%
    }
} //end of applyLabel.equals(submitValue)

//display form to add draft
%>
<body>
    <div id="header">
        <h1>DocuShare</h1>
        <h2><%= title %></h2>
        <div id="header-wrapper">
            <p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p>
        </div>
    </div>
<%
    // write tabs with bread-crumbs GUI if "return" location provided, otherwise add spacer
    if (returnTo != null) {
        String docTitle = curVersion.getTitle();
        String versionFileName = curVersion.getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
        versionFileName = dsrouting.removePoisonChars(versionFileName); //AR11042+
        String locationStr = MessageDB.get("docushare.amber.property_categories.location", locale);
        String Contains = MessageDB.get("breadcrumb_contains", locale);
%>
        <div class="breadcrumbs">
        <%= locationStr %>: <a href='<%= returnTo %>' target='_top'><%= returnToTag %></a> 
        <span title="<%= Contains %>">&raquo;</span>
        <a href='<%= contextPath %>/dsweb/Get/<%= curVersion.getHandle().toString() %>/<%= versionFileName %>'
            target='_new'><%= (docTitle == null) ? "" : docTitle %></a> <%= title %>
        </div>

        <div id="content">
        <h2><%= MessageDB.get("routing_add_version", locale) %></h2> 
<%
    }
if (errorMessage == null) {//AR17026 add if: show form
%>
        <FORM name="UNKNOWN" action="prop_add.jsp?returnTag=<%= URLEncoder.encode(returnToTag, "UTF-8") %>" method="POST" enctype="multipart/form-data">
        <table class="propstable">
        <tr>
            <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/document_filename')" target="_parent"><%= MessageDB.get("document_filename_label", locale) %>:</a>
            <small>(<%= MessageDB.get("form.required", locale) %>)</small></label></td>
            <td><input name="docFile" type="file" size="30" /></td>
        </tr>
        <tr>
            <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/title')" target="_parent"><%= MessageDB.get("title_label", locale) %>:</a>
            <small>(<%= MessageDB.get("form.required", locale) %>)</small></label></td>
            <td><input name='version_title' type='text' size="40" maxlength="256"
                value='<%= AmberUtility.xss_safe_value(dsDoc.getTitle()) %>' tabindex='1' /></td>
        </tr>
        <tr>
            <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/Version.revision_comments')"
                target="_parent"><%= MessageDB.get("routing_version_comments", locale) %>:</a></label></td>
            <td><input name='revision_comments' type='text' size="40" maxlength="256" value='' tabindex='1' /></td>
        </tr>
    <%
    if(!autoMovePreferredVersion && isPubNew) {//AR6781+     
    %>
        <tr>
            <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/set_as_preferred_version')"
                target="_parent"><%=MessageDB.get("set_as_preferred_version_label", locale)%>:</a></label></td>
            <td><INPUT TYPE="radio" NAME="setVersionPreferred" VALUE="true" tabindex="1">Yes</INPUT>
                <INPUT TYPE="radio" NAME="setVersionPreferred" VALUE="false" CHECKED="CHECKED" tabindex="1">No</INPUT></td>
        </tr>            
    <%}
    %>
        </table>
            
        <script language="javascript">
            function openHelpTextWindow(url) {
                var newUrl = url;
                var help_window=window.open(newUrl, "details_window", "toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=350,height=250");
                help_window.onClose = window.focus();
                help_window.focus();
            }
        </script>

        <input type="hidden" name="workFlowJobName" value="<%= workFlowJobName %>" />
<%
if(!btnReadOnly){//AR6202+
    out.print("<div id=\"buttonbar\"><input type=\"submit\" name=\"submit\" value=\""+ applyLabel +"\" /></div>");
}//AR6202+ %>
        <input type="hidden" name="document" value="<%= document %>" />
<%
    if(isPubNew) {//this _pubNew hidden is used for prop_add.jsp submit to itself:
%>
        <input type="hidden" name="_pubNew" value="<%= pubNew %>" />                
<%  }

    if (returnTo != null) {%>
        <input type="hidden" name="return" value="<%= returnTo %>" />
        <input type="hidden" name="returnTag" value="<%= returnToTag %>" />
<%  }
%>
        </form>
<%
} else {//AR17026 add else: show errorMessage
    if(errorCode == DSException.CONTENT_QUOTA_EXCEEDED) {//1157
%>
    <h2><font color="#339933"><%= MessageDB.get("InfoExceptionBanner", 
        new Object[]{MessageDB.get("info.quota_exceeded", locale)}, locale) %></font></h2>
    <p><%= MessageDB.get("info.detail.quota_exceeded", locale) %> </p>
<%
    }else{
%>
    <font color="red"> <strong><%= MessageDB.get("err.format", new Object[]{errorMessage}, locale) %></strong></font>
<%
    }
}
%>
    </div>
</body>
</html>