<!--
Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: tasks_assigned_to_me.jsp 93076 2015-12-03 08:10:45Z bchan $
-->

<!--
This page displays a list of tasks assigned to the current user by others,
and allows the user to select and review tasks.  Tasks are removed from this
list from the individual task GUIs after the user performs requested task
operations (e.g. approving/disapproving a routed documents).
-->

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>

<%@ page import="java.util.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<jsp:useBean id="indexUtilBean" scope="request" class="com.xerox.docushare.routing.IndexRangeUtilBean" >
  <jsp:setProperty name="indexUtilBean" property="*"/>
</jsp:useBean>

<%
    dsrouting.setDSSession(request); 
    String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
    request.setCharacterEncoding(dsrouting.getCharEncoding());
    response.setContentType(dsrouting.getContentType());

    /* Singapore team AR3446 Copyright messages not internationalized */
    DSSession dsSession = (DSSession)request.getAttribute("DSSession");
    Locale locale = dsSession.getLocale();
    DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
    String user = dsUser.toString();

    ArrayList myBeans = null;
    String[] asked = new String[] {TaskBean.SUBJECT, TaskBean.TASKTOMEDATE, TaskBean.REQUESTTYPE, TaskBean.URI, TaskBean.TASKID};
    String buttonLabelPrevious  = MessageDB.get("route_selector_button_previous", locale);
    String buttonLabelNext      = MessageDB.get("route_selector_button_next", locale);
    String buttonLabelShowAll   = MessageDB.get("showAll", locale);
    String uiNextPage      = MessageDB.get("nextPage", locale);
    String uiPreviousPage  = MessageDB.get("previousPage", locale);
    String uiBlankImage    = MessageDB.get("blank_image", locale);
    String uiTaskIcon    = MessageDB.get("task_icon", locale);

    int totalTaskCount = dsrouting.getTaskBeanForRecipientCount(user); // ForRecipient means TaskToMe

    // configurable
    indexUtilBean.setRangeMin("1");
    int initialStart = 1, initialEnd = 10;

    indexUtilBean.setRangeMax(""+totalTaskCount);
    int reqStartInt = initialStart;
    int reqEndInt = initialEnd;
    int pageSize = initialEnd - initialStart + 1;

    int pageCount = totalTaskCount/reqEndInt + ((totalTaskCount%reqEndInt==0) ? 0 : 1);
    int pageNumber = 1;

    // use the Bean value only if self-submitted, i.e. any of the following UI was activated    
    //System.out.println("pageDirection " + request.getParameter("pageDirection"));
    if( (request.getParameter("pageDirection") != null) && (request.getParameter("pageDirection").trim().length()!=0) )
    {
        String direction = request.getParameter("pageDirection");
        if(direction.equals("next") || direction.equals("previous"))
        {
            int oldPageNumberInt = Integer.parseInt(indexUtilBean.getPageRangeMenu());
            if(direction.equals("next"))
                pageNumber = oldPageNumberInt + 1;
            else
                pageNumber = oldPageNumberInt - 1;
            indexUtilBean.setPageRangeMenu(""+pageNumber);
            //reqStartInt = (pageNumber - 1) * pageSize + 1;
            //reqEndInt = pageNumber * pageSize ;
		%>
			<script language="javascript">
			<!--
				updateNextPrevious(<%=pageNumber%>);
			//-->
			</script>
		<%
        }
    }
    else if(request.getParameter("pageRangeMenu") != null)
    {
        String menuName = request.getParameter("pageRangeMenu");
        //System.out.println("pageRangeMenu " + menuName);
        if(menuName.equals(buttonLabelShowAll))
        {
            //System.out.println("pageRangeMenu going to show all");
            reqStartInt = initialStart;
            reqEndInt = totalTaskCount;
            pageNumber = 1;
        }
        else
        {
            //System.out.println("pageRangeMenu going to do something about " + menuName);
            int pageNumberWanted = Integer.parseInt(menuName);
			if(pageNumberWanted > pageCount)
	    	{
				%>
					<script language="javascript">
					<!--
						updateMyTasksAssignedToMeMinusOne(<%=pageNumberWanted%>);
					//-->
            		</script>
				<%
	    	}
            reqStartInt = (pageNumberWanted - 1) * pageSize + 1;
            reqEndInt = pageNumberWanted * pageSize ;
            pageNumber = pageNumberWanted;
        }
    }

    indexUtilBean.setStartIndex(""+reqStartInt);
    indexUtilBean.setEndIndex(""+reqEndInt);

    //System.out.println("reqStartInt = " + reqStartInt);
    //System.out.println("reqEndInt   = " + reqEndInt);

    if (dsrouting != null)
    {
        myBeans = dsrouting.getTaskBeanForRecipient(user, asked, reqStartInt, reqEndInt);
        
        // Bug: when recipient set done task 11, page 2 has no task and we are left with a blank page.
        // Check that there IS some task for display on previous page, then automatically rewind to that page.
        // Test setting done on task 1, 11, 21, 31 and 41 - based on initialEnd being at default value of 10.
        if( myBeans.size() == 0 && totalTaskCount > 0 )
        {
          pageNumber--;
          indexUtilBean.setPageRangeMenu(""+pageNumber);
          reqStartInt = (pageNumber - 1) * pageSize + 1;
          reqEndInt = pageNumber * pageSize ;
          indexUtilBean.setStartIndex(""+reqStartInt);
          indexUtilBean.setEndIndex(""+reqEndInt);
          myBeans = dsrouting.getTaskBeanForRecipient(user, asked, reqStartInt, reqEndInt);
        }
    }
    else
    {
%>
    <script language="javascript">
    <!--
        window.alert("<%= MessageDB.get("routing_contact_failed", locale) %>");
    //-->
    </script>
<%
    }
    if ((myBeans == null) || (myBeans.size() == 0))
    {
%>
    <p>&nbsp;<font class="VariableWidth9"><%= MessageDB.get("routing_no_assigned_tasks", locale) %></font><p>
<%
    }
    else
    {
%>

<form name="assignedToMe">
<input type="hidden" name="pageDirection" value="" />

<div class="toolbar_paging">
    <select size='1' name='pageRangeMenu' onChange='this.form.goPageButton.click()'>
        <% for(int i=1; i<=pageCount; i++) {
        %>
        <option value='<%= i %>' <%= indexUtilBean.isPageRangeMenuSelected(""+i) %> ><%=MessageDB.get("page_x_of_y", new Object[] {""+i,""+pageCount}, locale)%></option>
        <% } %>
        <option value='<%= buttonLabelShowAll %>' <%= indexUtilBean.isPageRangeMenuSelected(buttonLabelShowAll) %> ><%= buttonLabelShowAll %></option>
    </select>
    <% if(pageNumber>1) {
        %>
        <input type="image" onClick="this.form.pageDirection.value='previous';" alt='<%= uiPreviousPage %>' title='<%= uiPreviousPage %>' src="images/iconLtArrow_20x20.png" />
    <% } else { %>
        <img height="20" width="20" alt='<%= uiBlankImage %>' title='<%= uiBlankImage %>' src="images/iconLtArrow_dis.png">
    <% }
    if( (pageNumber<pageCount) && (reqEndInt!=totalTaskCount) ) {
        %>
        <input type="image" onClick="this.form.pageDirection.value='next';" alt='<%= uiNextPage %>' title='<%= uiNextPage %>' src="images/iconRtArrow_20x20.png" />
    <% } else { %>
        <img height="20" width="20" alt='<%= uiBlankImage %>' title='<%= uiBlankImage %>' src="images/iconRtArrow_dis.png">
    <% } %>
    
    <span style="visibility:hidden"><INPUT class="bs" type="SUBMIT" value="." border="0" name="goPageButton" /></span>
</div>

<table class="colltable">
    <col class="col_actions" />
    <col class="col_actions" />

    <tr>
        <th class="icon"></th>
        <th class="name"><%=MessageDB.get("routing_description", locale)%></th>
        <th><%=MessageDB.get("routing_type", locale)%></th>
        <th><%=MessageDB.get("routing_date", locale)%></th>
    </tr>
<%
        Iterator iterTask = myBeans.iterator();
        int lineCountForSeparator = 0;
        while (iterTask.hasNext())
        {
            lineCountForSeparator++;
            TaskBean aBean = (TaskBean)iterTask.next();

          try{//AR5812+

            String description = (String)aBean.get(TaskBean.SUBJECT);
			description = AmberUtility.xss_safe_value(description);
            String requestType = (String)aBean.get(TaskBean.REQUESTTYPE);
            requestType = dsrouting.getLocalizedTaskType(requestType, locale);
            
            // should this be encoded too, since it is passed to JavaScript?
            String uri = (String)aBean.get(TaskBean.URI);

            Date creationTime = (Date)aBean.get(TaskBean.TASKTOMEDATE);
            String dateStr = new SimpleDateFormat(MessageDB.get("date_short_2"+keySuffix, locale)).format(creationTime); //AR8506+

%>
    <TR>
        <td><img alt='<%= uiTaskIcon %>' title='<%= uiTaskIcon %>' src="images/action_routing.gif" /></td>
        <td class="name"><a class="uline" href="javascript:openTaskWindow('<%= uri %>')"><%= (description.length() == 0) ? "- &nbsp;"  : description %></a>
        </TD>
        <td><%= requestType %>&nbsp;</td>
        <td class="lightem"><%= dateStr %></td>
    </TR>
<%
          //AR5812+:
          }
          catch(Exception e) 
          {
              System.out.println("## load tasks_assigned_to_me, Task " + aBean.get(TaskBean.TASKID) + ": "+ e); //e.printStackTrace();
          }//end AR5812+
        }
    }
%>
</table>
</form>
<p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>
</div>
</body>
</html>
